;;;; -*- Mode: LISP; Syntax: ANSI-Common-Lisp; Base: 10 -*-
;;;; *************************************************************************
;;;; FILE IDENTIFICATION
;;;;
;;;; Name:          xlunit.asd
;;;; Purpose:       ASDF definition file for Xlunit
;;;; Programmer:    Kevin M. Rosenberg
;;;; Date Started:  Aug 2003
;;;;
;;;; $Id: xlunit.asd,v 1.3 2003/08/04 16:13:58 kevin Exp $
;;;; *************************************************************************

(defpackage #:xlunit-system (:use #:asdf #:cl))
(in-package #:xlunit-system)

(defsystem xlunit
  :name "xlunit"
  :author "Kevin Rosenberg based on work by Craig Brozensky"
  :maintainer "Kevin M. Rosenberg <kmr@debian.org>"
  :licence "BSD"
  :description "Extreme Lisp Testing Suite"
  :long-description "The XLUnit package is toolkit for building test suites. It is based on the XPTest package by Craig Brozensky and the JUnit package by Kent Beck."
  
  :serial t
  :components
  ((:file "package")
   (:file "assert")
   (:file "test-case")
   (:file "suite")
   (:file "listener")
   (:file "result")
   (:file "textui")
   (:file "printer")
   ))

(defmethod perform ((o test-op) (c (eql (find-system 'xlunit))))
  (oos 'load-op 'xlunit-tests :force t)
  (oos 'test-op 'xlunit-tests :force t))

(defsystem xlunit-tests
    :depends-on (xlunit)
    :components ((:file "tests")))

(defmethod perform ((o test-op) (c (eql (find-system 'xlunit-tests))))
  (or (funcall (intern (symbol-name '#:do-tests)
		       (find-package '#:xlunit-tests)))
      (error "test-op failed")))
